"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.print = void 0;
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
function printGeneratedTS(result, options) {
    fs_1.default.writeFileSync(path_1.default.join(options.outputDir, "index.ts"), result);
}
var reactQueryVersionMap = {
    v3: "\"react-query\": \"3.x.x\"",
    v4: "\"@tanstack/react-query\": \"4.x.x\"",
    v5: "\"@tanstack/react-query\": \"5.x.x\"",
};
function printPackageJson(options) {
    var _a;
    var pkgJson = "\n  {\n    \"name\": \"".concat(options.name, "\",\n    \"version\": \"").concat(options.packageVersion, "\",\n    \"description\": \"This package was generated by Rapini\",\n    \"module\": \"dist-esm/index.mjs\",\n    \"main\": \"dist/index.js\",\n    \"types\": \"dist/index.d.ts\",\n    \"exports\": {\n      \".\": {\n        \"import\": \"./dist-esm/index.mjs\",\n        \"require\": \"./dist/index.js\"\n      },\n      \"./package.json\": \"./package.json\"\n    },\n    \"license\": \"private\",\n    \"scripts\": {\n      \"build\": \"npm run build-cjs && npm run build-esm\",\n      \"build-cjs\": \"tsc index.ts --declaration --skipLibCheck --outDir dist\",\n      \"build-esm\": \"tsc index.ts --skipLibCheck --moduleResolution node --target es2015 --esModuleInterop --outDir dist-esm && mv dist-esm/index.js dist-esm/index.mjs\"\n    },\n    \"peerDependencies\": {\n      \"axios\": \"0.27.x\",\n      ").concat((_a = reactQueryVersionMap[options.reactQueryVersion]) !== null && _a !== void 0 ? _a : "\"@tanstack/react-query\": \"latest\"", "\n    },\n    \"devDependencies\": {\n      \"@types/node\": \"^17.0.34\",\n      \"typescript\": \"^4.6.4\"\n    }\n  }\n  ");
    fs_1.default.writeFileSync(path_1.default.join(options.outputDir, "package.json"), pkgJson);
}
function print(result, options) {
    if (!fs_1.default.existsSync(options.outputDir)) {
        fs_1.default.mkdirSync(options.outputDir);
    }
    printGeneratedTS(result, options);
    printPackageJson(options);
}
exports.print = print;
